Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.4 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.sasl
Class SaslServerPlainImpl

    java.lang.Object
      org.jivesoftware.openfire.sasl.SaslServerPlainImpl

All Implemented Interfaces:
  SaslServer

    public class SaslServerPlainImpl

extends Object
implements SaslServer

Implements the PLAIN server-side mechanism. (RFC 4616)

client ----- {authzid, authcid, password} -----> server

Each paramater sent to the server is seperated by a null character The authorization ID (authzid) may be empty.

Author:
  Jay Kline

Constructor Summary
`SaslServerPlainImpl(String protocol, String serverFqdn, Map props, CallbackHandler cbh)`

Method Summary
`void` | `dispose()` Disposes of any system resources or security-sensitive information the SaslServer might be using.
`byte[]` | `evaluateResponse(byte[] response)` Evaluates the response data and generates a challenge.
`String` | `getAuthorizationID()` Reports the authorization ID in effect for the client of this session.
`String` | `getMechanismName()` Returns the IANA-registered mechanism name of this SASL server.
`Object` | `getNegotiatedProperty(String propName)` Retrieves the negotiated property.
`boolean` | `isComplete()` Determines whether the authentication exchange has completed.
`byte[]` | `unwrap(byte[] incoming, int offset, int len)` Unwraps a byte array received from the client.
`byte[]` | `wrap(byte[] outgoing, int offset, int len)` Wraps a byte array to be sent to the client.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SaslServerPlainImpl

    public SaslServerPlainImpl(String protocol,
                               String serverFqdn,
                               Map props,
                               CallbackHandler cbh)
                        throws SaslException

Throws:
  `SaslException`

Method Detail

### getMechanismName

    public String getMechanismName()

  Returns the IANA-registered mechanism name of this SASL server. ("PLAIN").

  Specified by:
    `getMechanismName` in interface `SaslServer`
  Returns:
    A non-null string representing the IANA-registered mechanism name.

### evaluateResponse

    public byte[] evaluateResponse(byte[] response)
                            throws SaslException

  Evaluates the response data and generates a challenge. If a response is received from the client during the authentication process, this method is called to prepare an appropriate next challenge to submit to the client. The challenge is null if the authentication has succeeded and no more challenge data is to be sent to the client. It is non-null if the authentication must be continued by sending a challenge to the client, or if the authentication has succeeded but challenge data needs to be processed by the client. `isComplete()` should be called after each call to `evaluateResponse()`,to determine if any further response is needed from the client.

  Specified by:
    `evaluateResponse` in interface `SaslServer`
  Parameters:
    `response` - The non-null (but possibly empty) response sent by the client.
  Returns:
    The possibly null challenge to send to the client. It is null if the authentication has succeeded and there is no more challenge data to be sent to the client.
  Throws:
    `SaslException` - If an error occurred while processing the response or generating a challenge.

### isComplete

    public boolean isComplete()

  Determines whether the authentication exchange has completed. This method is typically called after each invocation of `evaluateResponse()` to determine whether the authentication has completed successfully or should be continued.

  Specified by:
    `isComplete` in interface `SaslServer`
  Returns:
    true if the authentication exchange has completed; false otherwise.

### getAuthorizationID

    public String getAuthorizationID()

  Reports the authorization ID in effect for the client of this session. This method can only be called if isComplete() returns true.

  Specified by:
    `getAuthorizationID` in interface `SaslServer`
  Returns:
    The authorization ID of the client.
  Throws:
    `IllegalStateException` - if this authentication session has not completed

### unwrap

    public byte[] unwrap(byte[] incoming,
                         int offset,
                         int len)
                  throws SaslException

  Unwraps a byte array received from the client. PLAIN supports no security layer.

  Specified by:
    `unwrap` in interface `SaslServer`
  Throws:
    `SaslException` - if attempted to use this method.

### wrap

    public byte[] wrap(byte[] outgoing,
                       int offset,
                       int len)
                throws SaslException

  Wraps a byte array to be sent to the client. PLAIN supports no security layer.

  Specified by:
    `wrap` in interface `SaslServer`
  Throws:
    `SaslException` - if attempted to use this method.

### getNegotiatedProperty

    public Object getNegotiatedProperty(String propName)

  Retrieves the negotiated property. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns true); otherwise, an `IllegalStateException` is thrown.

  Specified by:
    `getNegotiatedProperty` in interface `SaslServer`
  Parameters:
    `propName` - the property
  Returns:
    The value of the negotiated property. If null, the property was not negotiated or is not applicable to this mechanism.
  Throws:
    `IllegalStateException` - if this authentication exchange has not completed

### dispose

    public void dispose()
                 throws SaslException

  Disposes of any system resources or security-sensitive information the SaslServer might be using. Invoking this method invalidates the SaslServer instance. This method is idempotent.

  Specified by:
    `dispose` in interface `SaslServer`
  Throws:
    `SaslException` - If a problem was encountered while disposing the resources.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.4 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2007 Jive Software.